Subject: [FFC-dev] Error in mixed elements

From: Mehdi Nikbakht <[email-masked]>
Date: Thu, 21 Jun 2007 14:57:32 +0200

Hello,

I am trying to model a simple thermo-elasticity problem without coupling. Form
file looks like this:

P1 = FiniteElement("Lagrange", "triangle", 1)
P2 = VectorElement("Lagrange", "triangle", 1)

mixed = P2 + P1

(v, q) = TestFunctions(mixed)
(U, T) = TrialFunctions(mixed)

f = Function(P1)

E  = 10.0
nu = 0.3

mu    = E / (2*(1 + nu))
lmbda = E*nu / ((1 + nu) * (1 - 2*nu))

def epsilon(v):
    return 0.5 * (grad(v) + transp(grad(v)))

def sigma(U):
    return 2*mu*epsilon(U) + lmbda*mult(trace(epsilon(U)), Identity(len(U)))
    
a = dot(grad(v), sigma(U))*dx+ dot(grad(q), grad(T))*dx
L=f*q*dx

If you compile this file, you would see that the components related to
temperature aren't calculated correctly in the element tensor. They also have
strange dependency on the value of E. I tracked this error and I found out the
chageset 812, with summary simplify version 0.2, has broken something.

changeset:   812:c9b63179cee6
user:        "Marie E. Rognes <[email-masked]>"
date:        Wed May 16 03:46:15 2007 -0200
summary:     simplify version 0.2

-- 
Mehdi